##########################
##########################
### READ CANADA DATA

data.canada <- read.csv("./data/raw/DataCanada/Canada_Data2George_20130815.csv",header=TRUE,stringsAsFactors =FALSE)
head(data.canada)
dim(data.canada)
plot(data.canada[["Lon"]],data.canada[["Lat"]])

## plot on world map
library(rworldmap)
newmap <- getMap(resolution = "coarse")  # different resolutions available
plot(newmap)
points(data.canada[["Lon"]],data.canada[["Lat"]],cex=0.2,col="red")

data.canada <-  subset(data.canada,subset=!(is.na(data.canada[["Species_FIAcode"]]) & is.na(data.canada[["SubPlotSize"]])
                                            & is.na(data.canada[["InitDBH"]])))

test <-  BA.SP.FUN(id.tree=data.canada[["PLOTTREE_ID"]],
          diam=data.canada[["InitDBH"]],
          sp=data.canada[["Species_FIAcode"]],
          id.plot=paste(data.canada[["PlotID"]],data.canada[["SubPlotID"]]),
          weights=1/(10000*data.canada[["SubPlotSize"]]),
          weight.full.plot=NA)



## change NA and <0 data for 0
data.BA.SP <- test
data.BA.SP[which(is.na(data.BA.SP),arr.ind=TRUE)] <- 0
data.BA.SP[,-1][which(data.BA.SP[,-1]<0,arr.ind=TRUE)] <- 0

#### compute BA tot for all competitors
BATOT.COMPET <- apply(data.BA.SP[,-1],MARGIN=1,FUN=sum,na.rm=TRUE)
data.BA.SP$BATOT.COMPET <- BATOT.COMPET
