####################################################
####################################################
##### SPECIES LIST FOR WORKSHOP


#################################
#################################
#### READ SPECIES LIST I HAVE NOW FOR EACH SITES NON TROPICAL
#### (ASSUMING THAT TROPICAL SITES COMES WITH TRAITS DATA

#############################3
### US based on FIA full species list
Data.Species.FIA <- read.csv("./data/species.list/REF_SPECIES.CSV",stringsAsFactors=FALSE,na.strings="")
## head(Data.Species.FIA)
## merge genus & species 
Data.Species.FIA$sp <- gsub("spp.","sp",paste(Data.Species.FIA$GENUS,Data.Species.FIA$SPECIES))
Species.FIA.short <- Data.Species.FIA$sp[Data.Species.FIA$SPCD<6000]
Species.FIA.long <- Data.Species.FIA$sp

####################################
## US SPECIES Based on Burns and Honkala
BurnsAndHonkalaSpeciesSummary<- read.csv("./data/species.list/BurnsAndHonkalaSpeciesSummary.csv",
                  stringsAsFactors=FALSE,na.strings="",sep=";")
## head(BurnsAndHonkalaSpeciesSummary)
## clean species name
fun.get.sp <- function(x) gsub(paste(" ",gsub("^([a-zA-Z]* [a-zA-Z]* )","",x),sep=""),"",x,fixed=TRUE)
BurnsAndHonkalaSpeciesSummary$sp <- sapply(BurnsAndHonkalaSpeciesSummary[,"Scientific_name"],fun.get.sp)
Species.Burns <- BurnsAndHonkalaSpeciesSummary$sp


#########################################
### canada check http://en.wikipedia.org/wiki/List_of_trees_of_Canada
Data.canadian.species <- read.csv("./data/species.list/canadian.species.csv",stringsAsFactors=FALSE)
Species.Canada <-  Data.canadian.species$species

#########################
## SPAIN BASED ON TABLE PROVIDED BY MIGUEL
Data.Species.Spain<- read.csv("./data/species.list/List_120_SPP.csv",
                              stringsAsFactors=FALSE)
## head(Data.Species.Spain)
Species.Spain <- Data.Species.Spain$Scoentific.Name
#########################################
### SPECIE Sin Swizerland not in FRANCE
Species.Swiss <- c('Pinus montana','Ulmus scabra')

####################################3
#### SWEDEN 
Data.Sweden <- read.csv("./data/species.list/Swedish_NFI_tree_species.csv",
                        sep=";",stringsAsFactors=FALSE)
Species.Sweden <- Data.Sweden$Species

###########################
###########################
## NEW ZEALAND
load("./data/species.list/vec.code.nvs.Rdata") ### load list of species code from the NVS data I used to calibrate SORTIE
Data.NVS.species <- read.csv("./data/species.list/CurrentNVSNames.csv",sep=";",stringsAsFactors=FALSE)

table.NVS.tree <- Data.NVS.species[Data.NVS.species$NVS.Code %in% vec.code.nvs,]
write.csv(table.NVS.tree,file="./data/species.list/table.NVS.tree.csv")
Species.NZ <- table.NVS.tree$Species.Name

###########################
###########################
## NSW
Data.NSW <- read.csv("./data/species.list/Sub-trop_RF_trees.csv",sep=";",stringsAsFactors=FALSE)
Species.NSW <- Data.NSW$Species..trees...10cm.dbhob.


###########################################
###########################################
#### LOAD TRY SPECIES 
try.species <- read.csv("./data/species.list/SPECIES.TRY.csv",
                          stringsAsFactors=FALSE,header=TRUE)
## head(try.species,20)
## dim(try.species)

## genus already asked to try
genus.asked.try <- read.csv("./data/species.list/genus.asked.try.csv")$genus.asked.try

#### LIST OF ALL SPECIES with short FIA
species.vector <- unique(c(Species.Spain,Species.Canada,Species.Burns
 ,Species.Swiss,Species.Sweden,Species.NZ,Species.NSW,Species.FIA.short))
#

### get genus
fun.get.genus <- function(x) gsub(paste(" ",gsub("^([a-zA-Z]* )","",x),sep=""),"",x,fixed=TRUE)
Genus.tot <- unique(sapply(species.vector,fun.get.genus))

## all  FIA data
## species.vector2 <- unique(c(Species.Spain,Species.Canada,Species.Burns
##  ,Species.Swiss,Species.Sweden,as.character(Species.NZ),Species.NSW,Species.FIA.long))

## Genus.tot2 <- unique(sapply(species.vector2,fun.get.genus))


#### GENUS TO ASK 
GENUS.to.ASK <- Genus.tot[!(Genus.tot %in% genus.asked.try)]
## GENUS.to.ASK2 <- Genus.tot2[!(Genus.tot2 %in% genus.asked.try)]

## CHECK which genus are in TRY
GENUS.TRY <-   unique(sapply(try.species$AccSpeciesName,fun.get.genus))
#############################3
genus.list.short <- sort(GENUS.to.ASK[(GENUS.to.ASK %in% GENUS.TRY)])
write.csv(as.data.frame(genus.list.short),file="./data/process/genus.list.try.csv")
sort(GENUS.to.ASK[!(GENUS.to.ASK %in% GENUS.TRY)])
## genus.lis.long <- sort(GENUS.to.ASK2[(GENUS.to.ASK2 %in% GENUS.TRY)])
 
